import {Component, Inject} from '@angular/core';
import {MAT_DIALOG_DATA, MatDialogContent, MatDialogRef, MatDialogTitle} from "@angular/material/dialog";
import {TemplateType} from "../../../project/game-model/gamesystems/TemplateType";
import {Gamesystem} from "../../../project/game-model/gamesystems/Gamesystem";
import {MatFormField} from "@angular/material/form-field";
import {MatOption, MatSelect} from "@angular/material/select";
import {NgForOf} from "@angular/common";
import {FormControl, Validators} from "@angular/forms";

@Component({
  selector: 'app-template-system-editor',
  templateUrl: './template-system-editor.component.html',
  styleUrl: './template-system-editor.component.scss'
})
export class TemplateSystemEditorComponent {

  referenceCtrl: FormControl = new FormControl('', [Validators.required])

  constructor(private dialogRef: MatDialogRef<TemplateSystemEditorComponent>,
              @Inject(MAT_DIALOG_DATA) public templateSystems: Gamesystem<any, any>[] = []) {

  }

  cancel() {
    this.dialogRef.close()
  }

  submit() {
    this.dialogRef.close(this.referenceCtrl.value)
  }
}
