import {ModelComponent} from "../ModelComponent";
import {ModelComponentType} from "../ModelComponentType";
import { Gamesystem } from "../gamesystems/Gamesystem";
import { ProductGamesystem } from "../gamesystems/ProductGamesystem";
import { ProductTemplateGamesystem } from "../gamesystems/ProductTemplateGamesystem";
import { SimpleGamesystem } from "../gamesystems/SimpleGamesystem";
import { SimpleTemplateGamesystem } from "../gamesystems/SimpleTemplateGamesystem";

export class Character extends ModelComponent{

  characterSpecificGamesystems: Gamesystem<any, any>[] = []

  constructor(componentName: string, componentDescription: string) {
    super(componentName, componentDescription, ModelComponentType.CHARACTER);
  }

  addCharacterSpecificSimpleGamesystem(referenceSystem: SimpleGamesystem) {
    if(!this.findCharacterSpecificGameystemByName(referenceSystem.componentName)) {
      const templateGamesystem = new SimpleTemplateGamesystem(referenceSystem);
      this.characterSpecificGamesystems.push(templateGamesystem)
    }
  }

  addCharacterSpecificProductTemplateGamesystem(referenceSystem: ProductGamesystem) {
    if(!this.findCharacterSpecificGameystemByName(referenceSystem.componentName)) {
      const templateGamesystem = new ProductTemplateGamesystem(referenceSystem);
      this.characterSpecificGamesystems.push(templateGamesystem)
    }
  }


  findCharacterSpecificGameystemByName(referenceName: string) {
    return this.characterSpecificGamesystems.find(gamesystem => gamesystem.componentName === referenceName) != undefined
  }
}
